#include <QtWidgets/QApplication>
#include <QDir>
#include <QTranslator>
#include <QLocale>
#include "SystrayIcon.h"
#include "SettingsInfo.h"

int main(int argc, char ** argv)
{
    QApplication a(argc, argv);
    /* following setXXX direcly impact QSettings */
    a.setApplicationName("imapquickcheck");
    a.setApplicationVersion("20220207");
    a.setOrganizationDomain("imapquickcheck.org");
    a.setOrganizationName("ImapQuickCheck");

	QString transfilename = a.applicationName() + "_" +  QLocale::system().name();
	QStringList translocations;
	translocations.append( "/usr/share/" + a.applicationName() + "/translations/" + transfilename );
	translocations.append( "/usr/local/share/" + a.applicationName() + "/translations/" + transfilename );
	translocations.append( SettingsInfo::configDir() + "/" + transfilename );
	translocations.append( a.applicationDirPath() + "/" + transfilename );
	QTranslator translator;

	foreach (QString transfile, translocations)
	{
	  if (translator.load(transfile))
	  {
		a.installTranslator(&translator);
		break;
	  }
	}

    SystrayIcon systray(0);
    systray.show();
    a.setQuitOnLastWindowClosed(false);//a.connect( &app, SIGNAL( lastWindowClosed() ), &app, SLOT( quit() ) );
    return a.exec();
}
